﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Telerik.Windows.Controls;

namespace CustomLoopingListScenario
{
    public partial class MainPage : PhoneApplicationPage
    {
        private double selectedValue;
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            this.loopingList1.DataSource = new IntegerLoopingListDataSource(10);
            this.loopingList1.SelectedIndexChanged += this.OnLoopingList_SelectedIndexChanged;
            this.loopingList2.DataSource = new IntegerLoopingListDataSource(10);
            this.loopingList2.SelectedIndexChanged += this.OnLoopingList_SelectedIndexChanged;
            this.loopingList3.DataSource = new IntegerLoopingListDataSource(10);
            this.loopingList3.SelectedIndexChanged += this.OnLoopingList_SelectedIndexChanged;
            this.loopingList4.DataSource = new IntegerLoopingListDataSource(10);
            this.loopingList4.SelectedIndexChanged += this.OnLoopingList_SelectedIndexChanged;
            this.UpdateSelection();
        }

        private void OnLoopingList_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.UpdateSelectedValue();
        }

        private void UpdateSelectedValue()
        {
            int thousands = this.loopingList1.SelectedIndex;
            int hundreds = this.loopingList2.SelectedIndex;
            int tens = this.loopingList3.SelectedIndex; 
            int ones = this.loopingList4.SelectedIndex;

            this.selectedValue = thousands * 10.0 + hundreds + tens / 10.0 + ones / 100.0;
            this.txtValue.Text = "Value: " + this.selectedValue; 
        }

        private void UpdateSelection()
        {
            this.loopingList1.SelectedIndex = 0;
            this.loopingList2.SelectedIndex = 0;
            this.loopingList3.SelectedIndex = 0; 
            this.loopingList4.SelectedIndex = 0;
        }
    }

    public class IntegerLoopingListDataSource : LoopingListDataSource
    {
        public IntegerLoopingListDataSource(int count)
            : base(count)
        {
        }

        protected override LoopingListDataItem GetItemCore(int index)
        {
            return new LoopingListDataItem(index.ToString());
        }

        protected override void UpdateItemCore(LoopingListDataItem dataItem, int logicalIndex)
        {
            dataItem.Text = logicalIndex.ToString();
        }
    }
}